class Biodiff < Formula
  desc "Hex diff viewer using alignment algorithms from biology"
  homepage "https://github.com/8051Enthusiast/biodiff"
  url "https://github.com/8051Enthusiast/biodiff.git",
      tag:      "v1.2.1",
      revision: "48468e9e7493c5bec608035f86459feb2469be14"
  license "MIT"
  head "https://github.com/8051Enthusiast/biodiff.git", branch: "main"

  depends_on "cmake" => :build # for biodiff-wfa2-sys
  depends_on "rust" => :build

  uses_from_macos "llvm" # for libclang

  def install
    system "cargo", "install", *std_cargo_args
  end

  test do
    begin
      (testpath/"file1").write "foo"
      (testpath/"file2").write "bar"

      r, w, pid = PTY.spawn "#{bin}/biodiff file1 file2"
      sleep 1
      w.write "q"
      assert_match "unaligned            file1  | unaligned            file2", r.read

      assert_match version.to_s, shell_output("#{bin}/biodiff --version")
    rescue Errno::EIO
      # GNU/Linux raises EIO when read is done on closed pty
    end
  ensure
    Process.kill("TERM", pid)
    Process.wait(pid)
  end
end
